Index: dll/win32/shell32/dialogs/drvdefext.cpp
===================================================================
--- dll/win32/shell32/dialogs/drvdefext.cpp	(revision 67351)
+++ dll/win32/shell32/dialogs/drvdefext.cpp	(working copy)
@@ -223,20 +223,29 @@
         HBRUSH hbrOld = (HBRUSH)SelectObject(pDrawItem->hDC, hMagBrush);
         INT xRadial = xCenter + (INT)(cos(M_PI+m_FreeSpacePerc/100.0f*M_PI*2.0f)*cx/2);
         INT yRadial = yCenter - (INT)(sin(M_PI+m_FreeSpacePerc/100.0f*M_PI*2.0f)*cy/2);
-        Pie(pDrawItem->hDC,
-            pDrawItem->rcItem.left, pDrawItem->rcItem.top,
-            pDrawItem->rcItem.right, pDrawItem->rcItem.bottom - 10,
-            pDrawItem->rcItem.left, yCenter,
-            xRadial, yRadial);
+        if (m_FreeSpacePerc > 0)
+        {
+            Pie(pDrawItem->hDC,
+                pDrawItem->rcItem.left, pDrawItem->rcItem.top,
+                pDrawItem->rcItem.right, pDrawItem->rcItem.bottom - 10,
+                pDrawItem->rcItem.left, yCenter,
+                xRadial, yRadial);
 
-        SelectObject(pDrawItem->hDC, hBlueBrush);
-        Pie(pDrawItem->hDC,
-            pDrawItem->rcItem.left, pDrawItem->rcItem.top,
-            pDrawItem->rcItem.right, pDrawItem->rcItem.bottom - 10,
-            xRadial, yRadial,
-            pDrawItem->rcItem.left, yCenter);
-        SelectObject(pDrawItem->hDC, hbrOld);
-
+            SelectObject(pDrawItem->hDC, hBlueBrush);
+            Pie(pDrawItem->hDC,
+                pDrawItem->rcItem.left, pDrawItem->rcItem.top,
+                pDrawItem->rcItem.right, pDrawItem->rcItem.bottom - 10,
+                xRadial, yRadial,
+                pDrawItem->rcItem.left, yCenter);
+            SelectObject(pDrawItem->hDC, hbrOld);
+        }
+        else
+        {
+            SelectObject(pDrawItem->hDC, hBlueBrush);
+            Ellipse(pDrawItem->hDC,
+                    pDrawItem->rcItem.left, pDrawItem->rcItem.top,
+                    pDrawItem->rcItem.right, pDrawItem->rcItem.bottom - 10);
+        }
         HPEN hOldPen = (HPEN)SelectObject(pDrawItem->hDC, hDarkMagPen);
         for (INT x = pDrawItem->rcItem.left; x < pDrawItem->rcItem.right; ++x)
         {
@@ -272,6 +281,11 @@
         SetDlgItemTextW(hwndDlg, 14000, wszVolumeName);
         SetDlgItemTextW(hwndDlg, 14002, wszFileSystem);
     }
+    else
+    {
+        LoadStringW(shell32_hInstance, IDS_FS_UNKNOWN, wszFileSystem, _countof(wszFileSystem));
+        SetDlgItemTextW(hwndDlg, 14002, wszFileSystem);
+    }
 
     /* Set drive type and icon */
     UINT DriveType = GetDriveTypeW(m_wszDrive);
@@ -283,6 +297,10 @@
         case DRIVE_RAMDISK: IconId = IDI_SHELL_RAMDISK; break;
         default: IconId = IDI_SHELL_DRIVE; TypeStrId = IDS_DRIVE_FIXED;
     }
+    
+    if (DriveType != DRIVE_FIXED)
+        EnableWindow(GetDlgItem(hwndDlg, 14000), false);
+        
     HICON hIcon = (HICON)LoadImage(shell32_hInstance, MAKEINTRESOURCE(IconId), IMAGE_ICON, 32, 32, LR_SHARED);
     if (hIcon)
         SendDlgItemMessageW(hwndDlg, 14016, STM_SETICON, (WPARAM)hIcon, 0);
@@ -316,6 +334,23 @@
         if (StrFormatByteSizeW(TotalNumberOfBytes.QuadPart, wszBuf, _countof(wszBuf)))
             SetDlgItemTextW(hwndDlg, 14008, wszBuf);
     }
+    else
+    {
+        m_FreeSpacePerc = 0;
+        
+        if (SH_FormatByteSize(0, wszBuf, _countof(wszBuf)))
+        {
+            SetDlgItemTextW(hwndDlg, 14003, wszBuf);
+            SetDlgItemTextW(hwndDlg, 14005, wszBuf);
+            SetDlgItemTextW(hwndDlg, 14007, wszBuf);
+        }
+        if (StrFormatByteSizeW(0, wszBuf, _countof(wszBuf)))
+        {
+            SetDlgItemTextW(hwndDlg, 14004, wszBuf);
+            SetDlgItemTextW(hwndDlg, 14006, wszBuf);
+            SetDlgItemTextW(hwndDlg, 14008, wszBuf);
+        }
+    }
 
     /* Set drive description */
     WCHAR wszFormat[50];
Index: dll/win32/shell32/lang/bg-BG.rc
===================================================================
--- dll/win32/shell32/lang/bg-BG.rc	(revision 67351)
+++ dll/win32/shell32/lang/bg-BG.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Местен диск"
     IDS_DRIVE_CDROM "КД четец"
     IDS_DRIVE_NETWORK "Мрежов диск"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Отваряне с"
Index: dll/win32/shell32/lang/ca-ES.rc
===================================================================
--- dll/win32/shell32/lang/ca-ES.rc	(revision 67351)
+++ dll/win32/shell32/lang/ca-ES.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/cs-CZ.rc
===================================================================
--- dll/win32/shell32/lang/cs-CZ.rc	(revision 67351)
+++ dll/win32/shell32/lang/cs-CZ.rc	(working copy)
@@ -759,6 +759,7 @@
     IDS_DRIVE_FIXED "Místní disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Síťový Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Otevřít v"
Index: dll/win32/shell32/lang/da-DK.rc
===================================================================
--- dll/win32/shell32/lang/da-DK.rc	(revision 67351)
+++ dll/win32/shell32/lang/da-DK.rc	(working copy)
@@ -759,6 +759,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/de-DE.rc
===================================================================
--- dll/win32/shell32/lang/de-DE.rc	(revision 67351)
+++ dll/win32/shell32/lang/de-DE.rc	(working copy)
@@ -754,6 +754,7 @@
     IDS_DRIVE_FIXED "Lokaler Datenträger"
     IDS_DRIVE_CDROM "CD-Laufwerk"
     IDS_DRIVE_NETWORK "Netzlaufwerk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Öffnen mit..."
Index: dll/win32/shell32/lang/el-GR.rc
===================================================================
--- dll/win32/shell32/lang/el-GR.rc	(revision 67351)
+++ dll/win32/shell32/lang/el-GR.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Τοπικός δίσκος"
     IDS_DRIVE_CDROM "Μονάδα CD"
     IDS_DRIVE_NETWORK "Δίσκος δικτύου"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Άνοιγμαμε"
Index: dll/win32/shell32/lang/en-GB.rc
===================================================================
--- dll/win32/shell32/lang/en-GB.rc	(revision 67351)
+++ dll/win32/shell32/lang/en-GB.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/en-US.rc
===================================================================
--- dll/win32/shell32/lang/en-US.rc	(revision 67351)
+++ dll/win32/shell32/lang/en-US.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/es-ES.rc
===================================================================
--- dll/win32/shell32/lang/es-ES.rc	(revision 67351)
+++ dll/win32/shell32/lang/es-ES.rc	(working copy)
@@ -754,6 +754,7 @@
     IDS_DRIVE_FIXED "Disco local"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Unidad de red"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Abrir con"
Index: dll/win32/shell32/lang/fi-FI.rc
===================================================================
--- dll/win32/shell32/lang/fi-FI.rc	(revision 67351)
+++ dll/win32/shell32/lang/fi-FI.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/fr-FR.rc
===================================================================
--- dll/win32/shell32/lang/fr-FR.rc	(revision 67351)
+++ dll/win32/shell32/lang/fr-FR.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Disque local"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Disque réseau"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Ouvrir avec"
Index: dll/win32/shell32/lang/he-IL.rc
===================================================================
--- dll/win32/shell32/lang/he-IL.rc	(revision 67351)
+++ dll/win32/shell32/lang/he-IL.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "כונן מקומי"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "כונן רשת"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "פתיחה באמצעות"
Index: dll/win32/shell32/lang/hu-HU.rc
===================================================================
--- dll/win32/shell32/lang/hu-HU.rc	(revision 67351)
+++ dll/win32/shell32/lang/hu-HU.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/it-IT.rc
===================================================================
--- dll/win32/shell32/lang/it-IT.rc	(revision 67351)
+++ dll/win32/shell32/lang/it-IT.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Disco locale"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Disco di Rete"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Apri con"
Index: dll/win32/shell32/lang/ja-JP.rc
===================================================================
--- dll/win32/shell32/lang/ja-JP.rc	(revision 67351)
+++ dll/win32/shell32/lang/ja-JP.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "ローカル ディスク"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "ネットワーク ディスク"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "プログラムから開く"
Index: dll/win32/shell32/lang/ko-KR.rc
===================================================================
--- dll/win32/shell32/lang/ko-KR.rc	(revision 67351)
+++ dll/win32/shell32/lang/ko-KR.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/nl-NL.rc
===================================================================
--- dll/win32/shell32/lang/nl-NL.rc	(revision 67351)
+++ dll/win32/shell32/lang/nl-NL.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/no-NO.rc
===================================================================
--- dll/win32/shell32/lang/no-NO.rc	(revision 67351)
+++ dll/win32/shell32/lang/no-NO.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Lokal Disk"
     IDS_DRIVE_CDROM "CD stasjon"
     IDS_DRIVE_NETWORK "Nettverk disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Åpne med"
Index: dll/win32/shell32/lang/pl-PL.rc
===================================================================
--- dll/win32/shell32/lang/pl-PL.rc	(revision 67351)
+++ dll/win32/shell32/lang/pl-PL.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Dysk lokalny"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Dysk sieciowy"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Otwórz za pomocą"
Index: dll/win32/shell32/lang/pt-BR.rc
===================================================================
--- dll/win32/shell32/lang/pt-BR.rc	(revision 67351)
+++ dll/win32/shell32/lang/pt-BR.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Disco Local"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Disco de Rede"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Abrir Com"
Index: dll/win32/shell32/lang/pt-PT.rc
===================================================================
--- dll/win32/shell32/lang/pt-PT.rc	(revision 67351)
+++ dll/win32/shell32/lang/pt-PT.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Disco Local"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Disco de Rede"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Abre com..."
Index: dll/win32/shell32/lang/ro-RO.rc
===================================================================
--- dll/win32/shell32/lang/ro-RO.rc	(revision 67351)
+++ dll/win32/shell32/lang/ro-RO.rc	(working copy)
@@ -755,6 +755,7 @@
     IDS_DRIVE_FIXED "Disc local"
     IDS_DRIVE_CDROM "CD-ROM"
     IDS_DRIVE_NETWORK "Disc din rețea"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Deschide cu"
Index: dll/win32/shell32/lang/ru-RU.rc
===================================================================
--- dll/win32/shell32/lang/ru-RU.rc	(revision 67351)
+++ dll/win32/shell32/lang/ru-RU.rc	(working copy)
@@ -755,6 +755,7 @@
     IDS_DRIVE_FIXED "Локальный диск"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Сетевой диск"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Открыть с помощью"
Index: dll/win32/shell32/lang/sk-SK.rc
===================================================================
--- dll/win32/shell32/lang/sk-SK.rc	(revision 67351)
+++ dll/win32/shell32/lang/sk-SK.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Lokálny disk"
     IDS_DRIVE_CDROM "Jednotka CD"
     IDS_DRIVE_NETWORK "Sieťový disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Otvoriť v progra&me"
Index: dll/win32/shell32/lang/sl-SI.rc
===================================================================
--- dll/win32/shell32/lang/sl-SI.rc	(revision 67351)
+++ dll/win32/shell32/lang/sl-SI.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/sq-AL.rc
===================================================================
--- dll/win32/shell32/lang/sq-AL.rc	(revision 67351)
+++ dll/win32/shell32/lang/sq-AL.rc	(working copy)
@@ -757,6 +757,7 @@
     IDS_DRIVE_FIXED "Disku Vendorë"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Disku Rrjetit"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Hap me"
Index: dll/win32/shell32/lang/sv-SE.rc
===================================================================
--- dll/win32/shell32/lang/sv-SE.rc	(revision 67351)
+++ dll/win32/shell32/lang/sv-SE.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/lang/tr-TR.rc
===================================================================
--- dll/win32/shell32/lang/tr-TR.rc	(revision 67351)
+++ dll/win32/shell32/lang/tr-TR.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Yerel Disk"
     IDS_DRIVE_CDROM "Optik Sürücü"
     IDS_DRIVE_NETWORK "Ağ Sürücüsü"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Birlikte Aç"
Index: dll/win32/shell32/lang/uk-UA.rc
===================================================================
--- dll/win32/shell32/lang/uk-UA.rc	(revision 67351)
+++ dll/win32/shell32/lang/uk-UA.rc	(working copy)
@@ -753,6 +753,7 @@
     IDS_DRIVE_FIXED "Локальний диск"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Мережний диск"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Відкрити за допомогою"
Index: dll/win32/shell32/lang/zh-CN.rc
===================================================================
--- dll/win32/shell32/lang/zh-CN.rc	(revision 67351)
+++ dll/win32/shell32/lang/zh-CN.rc	(working copy)
@@ -762,6 +762,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "打开方式"
Index: dll/win32/shell32/lang/zh-TW.rc
===================================================================
--- dll/win32/shell32/lang/zh-TW.rc	(revision 67351)
+++ dll/win32/shell32/lang/zh-TW.rc	(working copy)
@@ -761,6 +761,7 @@
     IDS_DRIVE_FIXED "Local Disk"
     IDS_DRIVE_CDROM "CDROM"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
     IDS_OPEN_WITH "Open With"
Index: dll/win32/shell32/shresdef.h
===================================================================
--- dll/win32/shell32/shresdef.h	(revision 67351)
+++ dll/win32/shell32/shresdef.h	(working copy)
@@ -107,6 +107,7 @@
 #define IDS_DRIVE_FIXED          72
 #define IDS_DRIVE_CDROM          73
 #define IDS_DRIVE_NETWORK        74
+#define IDS_FS_UNKNOWN           75
 
 #define IDS_LOGOFF_TITLE  78
 #define IDS_LOGOFF_PROMPT 79