Index: dll/win32/shell32/shresdef.h
===================================================================
--- dll/win32/shell32/shresdef.h	(revision 67478)
+++ dll/win32/shell32/shresdef.h	(working copy)
@@ -107,7 +107,9 @@
 #define IDS_DRIVE_FIXED          72
 #define IDS_DRIVE_CDROM          73
 #define IDS_DRIVE_NETWORK        74
-#define IDS_FS_UNKNOWN           75
+#define IDS_DRIVE_FLOPPY         75
+#define IDS_DRIVE_REMOVABLE      76
+#define IDS_FS_UNKNOWN           77
 
 #define IDS_LOGOFF_TITLE  78
 #define IDS_LOGOFF_PROMPT 79
Index: dll/win32/shell32/lang/zh-TW.rc
===================================================================
--- dll/win32/shell32/lang/zh-TW.rc	(revision 67478)
+++ dll/win32/shell32/lang/zh-TW.rc	(working copy)
@@ -759,8 +759,10 @@
     IDS_NEWFOLDER "新資料夾"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/zh-CN.rc
===================================================================
--- dll/win32/shell32/lang/zh-CN.rc	(revision 67478)
+++ dll/win32/shell32/lang/zh-CN.rc	(working copy)
@@ -760,8 +760,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/uk-UA.rc
===================================================================
--- dll/win32/shell32/lang/uk-UA.rc	(revision 67478)
+++ dll/win32/shell32/lang/uk-UA.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "Нова папка"
 
     IDS_DRIVE_FIXED "Локальний диск"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Мережний диск"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/tr-TR.rc
===================================================================
--- dll/win32/shell32/lang/tr-TR.rc	(revision 67478)
+++ dll/win32/shell32/lang/tr-TR.rc	(working copy)
@@ -753,6 +753,8 @@
     IDS_DRIVE_FIXED "Yerel Disk"
     IDS_DRIVE_CDROM "Optik Sürücü"
     IDS_DRIVE_NETWORK "Ağ Sürücüsü"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/sv-SE.rc
===================================================================
--- dll/win32/shell32/lang/sv-SE.rc	(revision 67478)
+++ dll/win32/shell32/lang/sv-SE.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/sq-AL.rc
===================================================================
--- dll/win32/shell32/lang/sq-AL.rc	(revision 67478)
+++ dll/win32/shell32/lang/sq-AL.rc	(working copy)
@@ -755,8 +755,10 @@
     IDS_NEWFOLDER "Dosje e're"
 
     IDS_DRIVE_FIXED "Disku Vendorë"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Disku Rrjetit"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/sl-SI.rc
===================================================================
--- dll/win32/shell32/lang/sl-SI.rc	(revision 67478)
+++ dll/win32/shell32/lang/sl-SI.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/sk-SK.rc
===================================================================
--- dll/win32/shell32/lang/sk-SK.rc	(revision 67478)
+++ dll/win32/shell32/lang/sk-SK.rc	(working copy)
@@ -753,6 +753,8 @@
     IDS_DRIVE_FIXED "Lokálny disk"
     IDS_DRIVE_CDROM "Jednotka CD"
     IDS_DRIVE_NETWORK "Sieťový disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/ru-RU.rc
===================================================================
--- dll/win32/shell32/lang/ru-RU.rc	(revision 67478)
+++ dll/win32/shell32/lang/ru-RU.rc	(working copy)
@@ -753,8 +753,10 @@
     IDS_NEWFOLDER "Новая папка"
 
     IDS_DRIVE_FIXED "Локальный диск"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Сетевой диск"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/ro-RO.rc
===================================================================
--- dll/win32/shell32/lang/ro-RO.rc	(revision 67478)
+++ dll/win32/shell32/lang/ro-RO.rc	(working copy)
@@ -753,8 +753,10 @@
     IDS_NEWFOLDER "Dosar nou"
 
     IDS_DRIVE_FIXED "Disc local"
-    IDS_DRIVE_CDROM "CD-ROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Disc din rețea"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/pt-PT.rc
===================================================================
--- dll/win32/shell32/lang/pt-PT.rc	(revision 67478)
+++ dll/win32/shell32/lang/pt-PT.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "Nova Pasta"
 
     IDS_DRIVE_FIXED "Disco Local"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Disco de Rede"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/pt-BR.rc
===================================================================
--- dll/win32/shell32/lang/pt-BR.rc	(revision 67478)
+++ dll/win32/shell32/lang/pt-BR.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "Nova Pasta"
 
     IDS_DRIVE_FIXED "Disco Local"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Disco de Rede"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/pl-PL.rc
===================================================================
--- dll/win32/shell32/lang/pl-PL.rc	(revision 67478)
+++ dll/win32/shell32/lang/pl-PL.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "Nowy katalog"
 
     IDS_DRIVE_FIXED "Dysk lokalny"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Dysk sieciowy"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/no-NO.rc
===================================================================
--- dll/win32/shell32/lang/no-NO.rc	(revision 67478)
+++ dll/win32/shell32/lang/no-NO.rc	(working copy)
@@ -753,6 +753,8 @@
     IDS_DRIVE_FIXED "Lokal Disk"
     IDS_DRIVE_CDROM "CD stasjon"
     IDS_DRIVE_NETWORK "Nettverk disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/nl-NL.rc
===================================================================
--- dll/win32/shell32/lang/nl-NL.rc	(revision 67478)
+++ dll/win32/shell32/lang/nl-NL.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/ko-KR.rc
===================================================================
--- dll/win32/shell32/lang/ko-KR.rc	(revision 67478)
+++ dll/win32/shell32/lang/ko-KR.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/ja-JP.rc
===================================================================
--- dll/win32/shell32/lang/ja-JP.rc	(revision 67478)
+++ dll/win32/shell32/lang/ja-JP.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "新しいフォルダ"
 
     IDS_DRIVE_FIXED "ローカル ディスク"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "ネットワーク ディスク"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/it-IT.rc
===================================================================
--- dll/win32/shell32/lang/it-IT.rc	(revision 67478)
+++ dll/win32/shell32/lang/it-IT.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "Nuova cartella"
 
     IDS_DRIVE_FIXED "Disco locale"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Disco di Rete"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/hu-HU.rc
===================================================================
--- dll/win32/shell32/lang/hu-HU.rc	(revision 67478)
+++ dll/win32/shell32/lang/hu-HU.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/he-IL.rc
===================================================================
--- dll/win32/shell32/lang/he-IL.rc	(revision 67478)
+++ dll/win32/shell32/lang/he-IL.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "תיקייה חדשה"
 
     IDS_DRIVE_FIXED "כונן מקומי"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "כונן רשת"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/fr-FR.rc
===================================================================
--- dll/win32/shell32/lang/fr-FR.rc	(revision 67478)
+++ dll/win32/shell32/lang/fr-FR.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "Nouveau dossier"
 
     IDS_DRIVE_FIXED "Disque local"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Disque réseau"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/fi-FI.rc
===================================================================
--- dll/win32/shell32/lang/fi-FI.rc	(revision 67478)
+++ dll/win32/shell32/lang/fi-FI.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/es-ES.rc
===================================================================
--- dll/win32/shell32/lang/es-ES.rc	(revision 67478)
+++ dll/win32/shell32/lang/es-ES.rc	(working copy)
@@ -752,8 +752,10 @@
     IDS_NEWFOLDER "Nueva carpeta"
 
     IDS_DRIVE_FIXED "Disco local"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Unidad de red"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/en-US.rc
===================================================================
--- dll/win32/shell32/lang/en-US.rc	(revision 67478)
+++ dll/win32/shell32/lang/en-US.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/en-GB.rc
===================================================================
--- dll/win32/shell32/lang/en-GB.rc	(revision 67478)
+++ dll/win32/shell32/lang/en-GB.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/el-GR.rc
===================================================================
--- dll/win32/shell32/lang/el-GR.rc	(revision 67478)
+++ dll/win32/shell32/lang/el-GR.rc	(working copy)
@@ -753,6 +753,8 @@
     IDS_DRIVE_FIXED "Τοπικός δίσκος"
     IDS_DRIVE_CDROM "Μονάδα CD"
     IDS_DRIVE_NETWORK "Δίσκος δικτύου"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/de-DE.rc
===================================================================
--- dll/win32/shell32/lang/de-DE.rc	(revision 67478)
+++ dll/win32/shell32/lang/de-DE.rc	(working copy)
@@ -754,6 +754,8 @@
     IDS_DRIVE_FIXED "Lokaler Datenträger"
     IDS_DRIVE_CDROM "CD-Laufwerk"
     IDS_DRIVE_NETWORK "Netzlaufwerk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/da-DK.rc
===================================================================
--- dll/win32/shell32/lang/da-DK.rc	(revision 67478)
+++ dll/win32/shell32/lang/da-DK.rc	(working copy)
@@ -757,8 +757,10 @@
     IDS_NEWFOLDER "Ny Mappe"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/cs-CZ.rc
===================================================================
--- dll/win32/shell32/lang/cs-CZ.rc	(revision 67478)
+++ dll/win32/shell32/lang/cs-CZ.rc	(working copy)
@@ -757,8 +757,10 @@
     IDS_NEWFOLDER "Nová složka"
 
     IDS_DRIVE_FIXED "Místní disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Síťový Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/ca-ES.rc
===================================================================
--- dll/win32/shell32/lang/ca-ES.rc	(revision 67478)
+++ dll/win32/shell32/lang/ca-ES.rc	(working copy)
@@ -751,8 +751,10 @@
     IDS_NEWFOLDER "New Folder"
 
     IDS_DRIVE_FIXED "Local Disk"
-    IDS_DRIVE_CDROM "CDROM"
+    IDS_DRIVE_CDROM "CD Drive"
     IDS_DRIVE_NETWORK "Network Disk"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */
Index: dll/win32/shell32/lang/bg-BG.rc
===================================================================
--- dll/win32/shell32/lang/bg-BG.rc	(revision 67478)
+++ dll/win32/shell32/lang/bg-BG.rc	(working copy)
@@ -753,6 +753,8 @@
     IDS_DRIVE_FIXED "Местен диск"
     IDS_DRIVE_CDROM "КД четец"
     IDS_DRIVE_NETWORK "Мрежов диск"
+    IDS_DRIVE_FLOPPY "3.5 Floppy"
+    IDS_DRIVE_REMOVABLE "Removable Disk"
     IDS_FS_UNKNOWN "Unknown"
 
     /* Open With */