Index: base/shell/explorer/trayntfy.cpp
===================================================================
--- base/shell/explorer/trayntfy.cpp	(revision 67705)
+++ base/shell/explorer/trayntfy.cpp	(working copy)
@@ -1447,6 +1447,7 @@
 
     LRESULT DrawBackground(HDC hdc)
     {
+        HRESULT res;
         RECT rect;
 
         GetClientRect(&rect);
@@ -1458,10 +1459,10 @@
                 DrawThemeParentBackground(m_hWnd, hdc, &rect);
             }
 
-            DrawThemeBackground(TrayTheme, hdc, TNP_BACKGROUND, 0, &rect, 0);
+            res = DrawThemeBackground(TrayTheme, hdc, TNP_BACKGROUND, 0, &rect, 0);
         }
 
-        return TRUE;
+        return res;
     }
 
     LRESULT OnEraseBackground(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
Index: base/shell/explorer/traywnd.cpp
===================================================================
--- base/shell/explorer/traywnd.cpp	(revision 67705)
+++ base/shell/explorer/traywnd.cpp	(working copy)
@@ -1838,6 +1838,7 @@
     {
         RECT rect;
         int partId;
+        HRESULT res;
 
         GetClientRect(&rect);
 
@@ -1860,11 +1861,10 @@
                 partId = TBP_BACKGROUNDBOTTOM;
                 break;
             }
-
-            DrawThemeBackground(m_Theme, hdc, partId, 0, &rect, 0);
+            res = DrawThemeBackground(m_Theme, hdc, partId, 0, &rect, 0);
         }
 
-        return TRUE;
+        return res;
     }
 
     LRESULT OnEraseBackground(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
@@ -1911,7 +1911,10 @@
             rect.bottom = rect.top + GetSystemMetrics(SM_CYSIZEFRAME);
             break;
         }
-
+        if (IsThemeBackgroundPartiallyTransparent(m_Theme, backoundPart, 0))
+        {
+            DrawThemeParentBackground(m_hWnd, hdc, &rect);
+        }
         DrawThemeBackground(m_Theme, hdc, backoundPart, 0, &rect, 0);
 
         ReleaseDC(m_hWnd, hdc);
Index: dll/win32/comctl32/rebar.c
===================================================================
--- dll/win32/comctl32/rebar.c	(revision 67705)
+++ dll/win32/comctl32/rebar.c	(working copy)
@@ -1831,6 +1831,17 @@
     HRGN hrgn;
 
     GetClientRect (infoPtr->hwndSelf, &cr);
+
+#ifdef __REACTOS__
+    if (theme)
+    {
+        if (IsThemeBackgroundPartiallyTransparent(theme, RP_BACKGROUND, 0))
+        {
+            DrawThemeParentBackground (infoPtr->hwndSelf, hdc, &cr);
+        }
+        DrawThemeBackground (theme, hdc, 0, 0, &cr, NULL);
+    }
+#endif
     hrgn = CreateRectRgn(cr.left, cr.top, cr.right, cr.bottom);
 
     oldrow = -1;
@@ -1921,6 +1932,9 @@
 #endif
 	}
 
+#ifdef __REACTOS__
+        if (!theme)
+#else
         if (theme)
         {
             /* When themed, the background color is ignored (but not a
@@ -1928,6 +1942,7 @@
             DrawThemeBackground (theme, hdc, 0, 0, &cr, &rcBand);
         }
         else
+#endif
         {
             old = SetBkColor (hdc, new);
             TRACE("%s background color=0x%06x, band %s\n",
@@ -1945,6 +1960,9 @@
     }
 
 #if 1
+#ifdef __REACTOS__
+    if (!theme)
+#endif
     {
         //FIXME: Apparently painting the remaining area is a v6 feature
         HBRUSH hbrush = CreateSolidBrush(new);
@@ -3243,7 +3261,11 @@
     else if ((theme = GetWindowTheme (infoPtr->hwndSelf)))
     {
         /* FIXME: should use GetThemeInt */
+#ifdef __REACTOS__
+        rect->top = (rect->top + 1 < rect->bottom) ? rect->top : rect->bottom;
+#else
         rect->top = min(rect->top + 1, rect->bottom);
+#endif
     }
     TRACE("new client=(%s)\n", wine_dbgstr_rect(rect));
     return 0;
Index: dll/win32/uxtheme/draw.c
===================================================================
--- dll/win32/uxtheme/draw.c	(revision 67705)
+++ dll/win32/uxtheme/draw.c	(working copy)
@@ -2087,6 +2087,7 @@
 
     GetThemeEnumValue(hTheme, iPartId, iStateId, TMT_BGTYPE, &bgtype);
 
+    if (bgtype == BT_NONE) return TRUE;
     if (bgtype != BT_IMAGEFILE) return FALSE;
 
     if(FAILED (UXTHEME_LoadImage (hTheme, 0, iPartId, iStateId, &rect, FALSE, 
Index: dll/win32/uxtheme/msstyles.c
===================================================================
--- dll/win32/uxtheme/msstyles.c	(revision 67705)
+++ dll/win32/uxtheme/msstyles.c	(working copy)
@@ -763,6 +763,7 @@
 PTHEME_CLASS MSSTYLES_OpenThemeClass(PTHEME_FILE tf, LPCWSTR pszAppName, LPCWSTR pszClassList)
 {
     PTHEME_CLASS cls = NULL;
+    PTHEME_CLASS defaultCls = NULL;
     WCHAR szClassName[MAX_THEME_CLASS_NAME];
     LPCWSTR start;
     LPCWSTR end;
@@ -779,10 +780,14 @@
         start = end+1;
         cls = MSSTYLES_FindClass(tf, pszAppName, szClassName);
         if(cls) break;
+        if (!defaultCls)
+            defaultCls = MSSTYLES_FindClass(tf, NULL, szClassName);
     }
     if(!cls && *start) {
         lstrcpynW(szClassName, start, sizeof(szClassName)/sizeof(szClassName[0]));
         cls = MSSTYLES_FindClass(tf, pszAppName, szClassName);
+        if (!defaultCls)
+            defaultCls = MSSTYLES_FindClass(tf, NULL, szClassName);
     }
     if(cls) {
         TRACE("Opened app %s, class %s from list %s\n", debugstr_w(cls->szAppName), debugstr_w(cls->szClassName), debugstr_w(pszClassList));
@@ -790,6 +795,14 @@
 	cls->tf->dwRefCount++;
     TRACE("Theme %p refcount: %d\n", tf, tf->dwRefCount);
     }
+    else if (defaultCls)
+    {
+        cls = defaultCls;
+        TRACE("Opened default class %s from list %s\n", debugstr_w(cls->szClassName), debugstr_w(pszClassList));
+        cls->tf = tf;
+        cls->tf->dwRefCount++;
+        TRACE("Theme %p refcount: %d\n", tf, tf->dwRefCount);
+    }
     return cls;
 }
 